/************************************************************************
 compteur.cpp
 
 Ce programme teste les possibilités d'incohérence provoquées par
 des accès concurrents (condition de course) à une même donnée.
 
 Le programme crée deux fils d'exécution qui incrémente la même 
 variable globale («cpt»)
 
*************************************************************************/
#include <thread>
#include <iostream>
#include <vector>

using namespace std;

//-------------------------
// Variable partagée 
int cpt = 0;

//----------------------------------------------
// Fil d'exécution qui incrémente 10000 fois cpt
//----------------------------------------------
void fil(int no)
{
    for(int i = 0; i < 10000; ++i)
    {
           cpt++;
    }
    cout << "Fin du fil "<< no << endl;
}
//===================================================
//
//  Programme qui initialise et démarre les fils
//  à la fin il imprime la valeur du compteur
//====================================================
int main(){
  
    vector<thread> threads;
    for(int i = 0; i < 2; ++i) { threads.push_back(thread(fil, i)); }

    for(auto& thread : threads)  {  thread.join(); }

    std::cout << "Fin de l'exécution du programme avec cpt = " << cpt << std::endl;

    return 0;
}
